#include <TFT_eSPI.h>
#include <SPI.h>
// Wymaga konfiguracjie:
// C:\Users\siiee\Documents\Arduino\libraries\TFT_eSPI

TFT_eSPI tft = TFT_eSPI();   // domyślna konfiguracja z User_Setup.h

#define Version "0.1.1"
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include "AS726X.h"
// #define TFT_CS        5
// #define TFT_RST       4
// #define TFT_DC        2

#define Btn1 33             //on board: D33 gain
#define Btn2 34            //on board:  D34 menu
#define Btn3 35            //on board:  D35 LED

#define WHITE 0xFFFF
#define BLACK 0x0000
#define GRAY 0x8410
#define RED 0xF800
#define ORANGE 0xFA60
#define YELLOW 0xFFE0
#define LIME 0x07FF
#define GREEN 0x07E0
#define CYAN 0x07FF
#define AQUA 0x04FF
#define BLUE 0x001F
#define MAGENTA 0xF81F
#define PINK 0xF8FF
#define SPACE_4_TEXT 20

AS726X sensor;

int RawRed = 0;
int RawOrange = 0;
int RawYellow = 0;
int RawGreen = 0;
int RawBlue = 0;
int RawViolet = 0;
float CalcRed  = 0.0;
float CalcOrange = 0.0;
float CalcYellow = 0.0;
float CalcGreen = 0.0;
float CalcBlue = 0.0;
float CalcViolet = 0.0;
int HeightRed = 0;
int HeightOrange = 0;
int HeightYellow = 0;
int HeightGreen = 0;
int HeightBlue = 0;
int HeightViolet = 0;

byte gain = 3;            //  values: 0,1,2,3
byte old_gain = 3;        //  values: 0,1,2,3
float gainValue = 64;
int menu_number = 0;      //  values:0 menu 1,2,3
int old_menu_number = 0;  //  values:0 menu 1,2,3
int LedPower = 0;
int GraphHeight = 128;
int GrapWidth = 25;
float ReadCalcValues[6] = {0, 0, 0, 0, 0, 0};
float ReadRawValues[6] = {0, 0, 0, 0, 0, 0};
int CalcHeights[6] = {0, 0, 0, 0, 0, 0};
int minHeight = 0 ;
float maxValue = 0.0;
float minValue = 0.0;
float test_vle = 1.0;
char FloatInChar[20];
char ChValue[20];

void setup() {
  tft.init();
  tft.setRotation(1);
  tft.fillScreen(TFT_BLACK);
  tft.setTextColor(TFT_YELLOW, TFT_BLACK);
  tft.setTextSize(2);
  tft.drawString("Version:"+ String(Version), 0, 0);
  delay(500);
  Wire.begin();
  sensor.begin();
  pinMode(Btn1, INPUT);
  pinMode(Btn2, INPUT);
  pinMode(Btn3, INPUT);
  tft.fillRect(0, 0, 240, 240, TFT_BLACK);
}



void loop() {

  if (digitalRead(Btn1) == HIGH){
    setGain();
  }
  if (digitalRead(Btn2) == HIGH){
    setMenu();
  }
  if (digitalRead(Btn3) == HIGH){
    setLed();
  }

  tft.setTextSize(1);
  tft.setTextColor(TFT_WHITE, TFT_BLACK);
  if (old_menu_number != menu_number){
    tft.fillRect(0, 0, 240, 240, TFT_BLACK);
    old_menu_number = menu_number;
  }

  if (old_gain != gain){
    sensor.setGain(gain);
    old_gain = gain;
  }

  if (menu_number == 0 ) {//show menu
    tft.setTextSize(2);
    tft.drawString("GAIN:" + String(gainValue),0, 0);
    tft.drawString("LED:",0, 16);
    if (LedPower == 1){
      tft.drawString("ON   ",45, 16);
    } else {
      tft.drawString("OFF  ",45, 16);
    }
    tft.drawString("0:Menu",0, 32);
    tft.drawString("1:Calc.Values",0, 48);
    tft.drawString("2:Raw",0, 64);
    tft.drawString("3:Rel. Graph",0, 80);
    // tft.drawString("4:Calc. Graph",0, 96);
  }
// show calculated values
  if (menu_number == 1 ) {//show calculated values
    tft.drawString("1.Calc Values",0,0);
      tft.drawString("Gain: " + String(gainValue) + "  LED: ", 0,9);
    if (LedPower == 1){
      tft.drawString("ON  ",100, 10);
    } else {
      tft.drawString("OFF",100, 10);
    }

    tft.fillRect(0, 20, 160,18, TFT_RED);
    tft.fillRect(0, 38, 160,18, TFT_ORANGE);
    tft.fillRect(0, 56, 160,18, TFT_YELLOW);
    tft.fillRect(0, 74, 160,18, TFT_GREEN);
    tft.fillRect(0, 92, 160,18, TFT_BLUE);
    tft.fillRect(0, 110, 160,20, TFT_MAGENTA);
    tft.setTextSize(2);
    tft.setTextColor(TFT_BLACK, TFT_RED);
    tft.drawString("R:" + String(CalcRed),2, 22);
    tft.setTextColor(TFT_BLACK, TFT_ORANGE);
    tft.drawString("O:" + String(CalcOrange),2, 40);
    tft.setTextColor(TFT_BLACK, TFT_YELLOW);
    tft.drawString("Y:" + String(CalcYellow),2, 58);
    tft.setTextColor(TFT_BLACK, TFT_GREEN);
    tft.drawString("G:" + String(CalcGreen),2, 76);
    tft.setTextColor(TFT_BLACK, TFT_BLUE);
    tft.drawString("B:" + String(CalcBlue),2, 94);
    tft.setTextColor(TFT_BLACK, TFT_MAGENTA);
    tft.drawString("V:" + String(CalcViolet),2, 112);
  }
  // //show raw values
  if (menu_number == 2 || menu_number == 6) {
    tft.drawString("2.Raw Values",0,0);
      tft.drawString("Gain: " + String(gainValue) + "  LED: ", 0,10);
    if (LedPower == 1){
      tft.drawString("ON  ",100, 10);
    } else {
      tft.drawString("OFF",100, 10);
    }

    tft.fillRect(0, 20, 160,18, TFT_RED);
    tft.fillRect(0, 38, 160,18, TFT_ORANGE);
    tft.fillRect(0, 56, 160,18, TFT_YELLOW);
    tft.fillRect(0, 74, 160,18, TFT_GREEN);
    tft.fillRect(0, 92, 160,18, TFT_BLUE);
    tft.fillRect(0, 110, 160,20, TFT_MAGENTA);
    tft.setTextSize(2);
    tft.setTextColor(TFT_BLACK, TFT_RED);
    tft.drawString("R:" + String(RawRed),2, 22);
    tft.setTextColor(TFT_BLACK, TFT_ORANGE);
    tft.drawString("O:" + String(RawOrange),2, 40);
    tft.setTextColor(TFT_BLACK, TFT_YELLOW);
    tft.drawString("Y:" + String(RawYellow),2, 58);
    tft.setTextColor(TFT_BLACK, TFT_GREEN);
    tft.drawString("G:" + String(RawGreen),2, 76);
    tft.setTextColor(TFT_BLACK, TFT_BLUE);
    tft.drawString("B:" + String(RawBlue),2, 94);
    tft.setTextColor(TFT_BLACK, TFT_MAGENTA);
    tft.drawString("V:" + String(RawViolet),2, 112);
  }
  //show relative calculated values graph
   if (menu_number == 3){
    tft.setTextColor(TFT_WHITE, TFT_BLACK);

    maxValue = 0.0;
    minValue = 0.0;
    for (int i = 0; i < 6; i++) {
        maxValue = max(maxValue, ReadCalcValues[i]);
    }
    for (int i = 0; i < 6; i++) {
        minValue = min(minValue, ReadCalcValues[i]);
    }

    CalcHeights[0] = HeightRed;
    CalcHeights[1] = HeightOrange;
    CalcHeights[2] = HeightYellow;
    CalcHeights[3] = HeightGreen;
    CalcHeights[4] = HeightBlue;
    CalcHeights[5] = HeightViolet;
        for (int i = 0; i < 6; i++) {
        minHeight = min(minHeight, CalcHeights[i]);
      }
    tft.fillRect(0, 20, 160, GraphHeight - minHeight- SPACE_4_TEXT, TFT_BLACK);
    HeightRed     = int((CalcRed     / maxValue) * (GraphHeight - SPACE_4_TEXT));
    HeightOrange  = int((CalcOrange  / maxValue) * (GraphHeight - SPACE_4_TEXT));
    HeightYellow  = int((CalcYellow  / maxValue) * (GraphHeight - SPACE_4_TEXT));
    HeightGreen   = int((CalcGreen   / maxValue) * (GraphHeight - SPACE_4_TEXT));
    HeightBlue    = int((CalcBlue    / maxValue) * (GraphHeight - SPACE_4_TEXT));
    HeightViolet  = int((CalcViolet  / maxValue) * (GraphHeight - SPACE_4_TEXT));


    tft.setTextColor(TFT_WHITE, TFT_BLACK);
    tft.drawString("3.Relvative Calculated Values",0,0);
    tft.drawString("Gain: " + String(gainValue) + "  LED: ", 0,10);
    if (LedPower == 1){
      tft.drawString("ON  ",100, 10);
    } else {
      tft.drawString("OFF",100, 10);
    }
    tft.fillRect(0 * GrapWidth,     GraphHeight - HeightRed,    GrapWidth, HeightRed,     TFT_RED);
    tft.fillRect(1 * GrapWidth + 1, GraphHeight - HeightOrange, GrapWidth, HeightOrange,  TFT_ORANGE);
    tft.fillRect(2 * GrapWidth + 2, GraphHeight - HeightYellow, GrapWidth, HeightYellow,  TFT_YELLOW);
    tft.fillRect(3 * GrapWidth + 3, GraphHeight - HeightGreen,  GrapWidth, HeightGreen,   TFT_GREEN);
    tft.fillRect(4 * GrapWidth + 4, GraphHeight - HeightBlue,   GrapWidth, HeightBlue,    TFT_BLUE);
    tft.fillRect(5 * GrapWidth + 5, GraphHeight - HeightViolet, GrapWidth, HeightViolet,  TFT_MAGENTA);

    // tft.setCursor(1 * GrapWidth -10, 0);
    tft.setTextColor(TFT_BLACK, TFT_RED);
    tft.drawString(" R:",1 * GrapWidth -20, 120);
    tft.setTextColor(TFT_BLACK, TFT_ORANGE);
    tft.drawString(" O:",2 * GrapWidth -19, 120);
    tft.setTextColor(TFT_BLACK, TFT_YELLOW);
    tft.drawString(" Y:",3 * GrapWidth -18, 120);
    tft.setTextColor(TFT_BLACK, TFT_GREEN);
    tft.drawString(" G:",4 * GrapWidth -17, 120);
    tft.setTextColor(TFT_BLACK, TFT_BLUE);
    tft.drawString(" B:",5 * GrapWidth -16, 120);
    tft.setTextColor(TFT_BLACK, TFT_MAGENTA);
    tft.drawString(" V:",6 * GrapWidth -15, 120);
     maxValue = 0.0;
     minValue = 0.0;
    }



    // // //show relative raw data  graph
    // if (menu_number == 4){
    // tft.setTextColor(TFT_WHITE, TFT_BLACK);
    // maxValue = 0.0;
    // minValue = 0.0;
    // for (int i = 0; i < 5; i++) {
    //     maxValue = max(maxValue, ReadRawValues[i]);
    // }
    // for (int i = 0; i < 5; i++) {
    //     minValue = min(minValue, ReadRawValues[i]);
    // }

    // // HeightRed     = int(((RawRed + abs(minValue))     / (maxValue + abs(minValue))) * GraphHeight);
    // // HeightOrange  = int(((RawOrange + abs(minValue))  / (maxValue + abs(minValue))) * GraphHeight);
    // // HeightYellow  = int(((RawYellow + abs(minValue))  / (maxValue + abs(minValue))) * GraphHeight);
    // // HeightGreen   = int(((RawGreen + abs(minValue))   / (maxValue + abs(minValue))) * GraphHeight);
    // // HeightBlue    = int(((RawBlue + abs(minValue))    / (maxValue + abs(minValue))) * GraphHeight);
    // // HeightViolet  = int(((RawViolet + abs(minValue))  / (maxValue + abs(minValue))) * GraphHeight);
    // tft.fillRect(minValue, 0, 240, maxValue-minValue, TFT_BLACK);
    // tft.setTextColor(TFT_WHITE, TFT_BLACK);
    // tft.drawString("4.Relvative Raw Values",0,0);
    // tft.drawString("Gain: " + String(gainValue) + "  LED: ", 0,10);
    // if (LedPower == 1){
    //   tft.drawString("ON  ",100, 10);
    // } else {
    //   tft.drawString("OFF",100, 10);
    // }

    // tft.fillRect(0 * GrapWidth,     GraphHeight - HeightRed,       GrapWidth, HeightRed + SPACE_4_TEXT,     TFT_RED);
    // tft.fillRect(1 * GrapWidth + 1, GraphHeight - HeightOrange,    GrapWidth, HeightOrange + SPACE_4_TEXT,  TFT_ORANGE);
    // tft.fillRect(2 * GrapWidth + 2, GraphHeight - HeightYellow, GrapWidth, HeightYellow + SPACE_4_TEXT,  TFT_YELLOW);
    // tft.fillRect(3 * GrapWidth + 3, GraphHeight - HeightGreen,  GrapWidth, HeightGreen + SPACE_4_TEXT,   TFT_GREEN);
    // tft.fillRect(4 * GrapWidth + 4, GraphHeight - HeightBlue,   GrapWidth, HeightBlue + SPACE_4_TEXT,    TFT_BLUE);
    // tft.fillRect(5 * GrapWidth + 5, GraphHeight - HeightViolet, GrapWidth, HeightViolet + SPACE_4_TEXT,  TFT_MAGENTA);
    // tft.setTextColor(TFT_BLACK, TFT_RED);
    // tft.drawString(" R:",1 * GrapWidth -20, 120);
    // tft.setTextColor(TFT_BLACK, TFT_ORANGE);
    // tft.drawString(" O:",2 * GrapWidth -19, 120);
    // tft.setTextColor(TFT_BLACK, TFT_YELLOW);
    // tft.drawString(" Y:",3 * GrapWidth -18, 120);
    // tft.setTextColor(TFT_BLACK, TFT_GREEN);
    // tft.drawString(" G:",4 * GrapWidth -17, 120);
    // tft.setTextColor(TFT_BLACK, TFT_BLUE);
    // tft.drawString(" B:",5 * GrapWidth -16, 120);
    // tft.setTextColor(TFT_BLACK, TFT_MAGENTA);
    // tft.drawString(" V:",6 * GrapWidth -15, 120);
    //  maxValue = 0.0;
    //  minValue = 0.0;
    // }


  if (gain == 0 ) {
    gainValue = 1;
  } else if (gain == 1) {
    gainValue = 3.7;
  } else if (gain == 2) {
    gainValue = 16;
  } else {
    gainValue = 64;
  }

  //data haverest
  if (menu_number != 0){
    if (LedPower == 1) {
      sensor.enableBulb();
      sensor.takeMeasurementsWithBulb();
    } else {
      sensor.disableBulb();
      sensor.takeMeasurements();
    }

    RawRed    = sensor.getRed();
    RawOrange = sensor.getOrange();
    RawYellow = sensor.getYellow();
    RawGreen  = sensor.getGreen();
    RawBlue   = sensor.getBlue();
    RawViolet = sensor.getViolet();

    CalcRed    = sensor.getCalibratedRed();
    CalcOrange = sensor.getCalibratedOrange();
    CalcYellow = sensor.getCalibratedYellow();
    CalcGreen  = sensor.getCalibratedGreen();
    CalcBlue   = sensor.getCalibratedBlue();
    CalcViolet = sensor.getCalibratedViolet();

    ReadRawValues[0] = RawRed;
    ReadRawValues[1] = RawOrange;
    ReadRawValues[2] = RawYellow;
    ReadRawValues[3] = RawGreen;
    ReadRawValues[4] = RawBlue;
    ReadRawValues[5] = RawViolet;

    ReadCalcValues[0] = CalcRed;
    ReadCalcValues[1] = CalcOrange;
    ReadCalcValues[2] = CalcYellow;
    ReadCalcValues[3] = CalcGreen;
    ReadCalcValues[4] = CalcBlue;
    ReadCalcValues[5] = CalcViolet;
  } else {
    delay(100);
  }

}

void setLed() {
  if (LedPower != 1 ) {
    LedPower = 1;
  } else {
    LedPower = 0;
  }
}
void setMenu() {
    if (menu_number < 3) {
      menu_number = menu_number + 1;
    } else {
      menu_number = 0;
    }
}
void setGain() {
    if (gain < 3) {
      gain = gain + 1;
    } else {
      gain = 0;
    }
}